#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "main.h"

/*Globals*/
int selected_pid = -1, selected_is_dead = FALSE;


void
on_newbutton_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  system("lsalarm &");
}


void
on_killbutton_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  if(selected_pid != -1)
  {
    /*Make sure we aren't killing a dead session*/
    if(!selected_is_dead)
    {
      kill(selected_pid, SIGTERM);
      sleep_little();
    }
    else
      msg_box("Cannot kill a dead session!\nUse delete instead", "Error");
    refresh_mainlist(user_data);
  }
}


void
on_resumebutton_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  char buf[PATH_MAX], buf2[NAME_MAX], *homedir = (char *)getenv("HOME");

  strcpy(buf, "lsalarm ");
  strcat(buf, homedir);
  strcat(buf, "/.lsalarm/sessions/");
  sprintf(buf2, "lsalarm-info.%d.txt &", selected_pid);
  strcat(buf, buf2);

  system(buf);
  sleep(1);

  refresh_mainlist(GTK_CLIST(user_data));
}


void
on_mainlist_select_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gchar *text;

  gtk_clist_get_text(GTK_CLIST(user_data), row, 0, &text);
  selected_pid = atoi(text);

  gtk_clist_get_text(GTK_CLIST(user_data), row, 1, &text);
  selected_is_dead = (text[0] == 'D');
}


void
on_refreshbutton_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  refresh_mainlist(GTK_CLIST(user_data));
}


void
on_deletebutton_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  if(selected_pid != -1)
  {
    /*Make sure we aren't killing a dead session*/
    if(selected_is_dead)
    {
      char buf[PATH_MAX], buf2[NAME_MAX], *homedir = (char *)getenv("HOME");

      strcpy(buf, homedir);
      strcat(buf, "/.lsalarm/sessions/");
      sprintf(buf2, "lsalarm-info.%d.txt", selected_pid);
      strcat(buf, buf2);

      remove(buf);
      sleep_little();
    }
    else
      msg_box("Delete is for dead sessions!\nUse kill instead", "Error");
    refresh_mainlist(user_data);
  }
}

